/*
 * ggTkgV.c:
 * Berechnen des
 * groesster gemeinsamer Teiler,
 * kleinstes gemeinsames Vielfaches
 * zweier natuerlicher Zahlen.
 */

                           /* Funktionsdeklarationen */
# include <stdio.h>

/*
 * ggT berechnet den groessten gemeinsamen Teiler
 * zweier natuerlicher Zahlen.
 */
unsigned int ggT( unsigned int, unsigned int);

/*
 * kgV berechnet das kleinste gemeinsamen Vielfache
 * zweier natuerlicher Zahlen.
 */
unsigned int kgV( unsigned int, unsigned int);


/*
 * Hauptfunktion, ruft die Berechnung auf.
 */
int main()
{
  unsigned int m, n;

/* Eingaben */
  printf( "m = "); scanf("%u", &m);
  printf( "n = "); scanf("%u", &n);

/* Ausgaben mit Funktionsaufruf */
  printf( "ggT( %d, %d) = %u\n", m, n, ggT( m, n));
  printf( "kgV( %d, %d) = %u\n", m, n, kgV( m, n));

  return 0;                  /* Funktionsruecksprung */
}


                            /* Funktionsdefinitionen */
/*
 * ggT berechnet den groessten gemeinsamen Teiler
 * zweier natuerlicher Zahlen nach Euklid.
 */
unsigned int ggT( unsigned int a, unsigned int b)
{
  unsigned int c;
  do
  {
    c = a % b;     /* Rest der ganzzahligen Division */
    a = b; b = c;           /* Vertauschen der Werte */
  } while( c != 0);

  return a;                  /* Funktionsruecksprung */
}


/*
 * kgV berechnet das kleinste gemeinsamen Vielfache
 * zweier natuerlicher Zahlen mittels ggT.
 */
unsigned int kgV( unsigned int a, unsigned int b)
{
  return a * b / ggT( a, b); /* Funktionsruecksprung */
}

