/*
 * Sortieren von Punkten mit Feldern von Strukturen
 */

# include <stdio.h>
# include <math.h>
# define MAX 10
# define M_PI 3.141593

struct kartes{ float x, y;};
struct polar{ float rho, phi;};
struct punkt{ struct kartes kar; struct polar pol;};

/*
 * Koordinatenumrechnung
 */
struct kartes kartesisch( struct polar);

/*
 * Sortierfunktion, Zeiger auf Struktur als Parameter
*/
void sortier_ein( struct punkt *, struct punkt, int);

int main()
{
  struct punkt v[ MAX], p;  /* v Feld von Strukturen */
  int gelesen = 0, i;

  printf( "Polarkoordinaten (Abstand/Winkel):\n");
  printf( "Schliessen Sie die Eingabe mit ^d ab!\n");
  printf( "\n");

/* Einlesen der Elemente der geschachtelten Struktur */
  while( gelesen < MAX &&
     ( scanf( "%f%f", &p.pol.rho, &p.pol.phi) != EOF ))
  {
    p.kar = kartesisch( p.pol);
    sortier_ein( v, p, gelesen++);
  }

                     /* Ausgabe der sortierten Folge */
  printf( "sortiert (polar/kartesisch):\n");
  for( i = 0; i < gelesen; i++)
  {
    printf( "(%f,%f) ", v[ i].pol.rho, v[ i].pol.phi);
    printf( "(%f,%f)\n", v[ i].kar.x, v[ i].kar.y);
  }

  return 0;
}


struct kartes kartesisch( struct polar p)
{
  struct kartes k;

  p.phi *= M_PI / 180;   /* Winkelmass --> Bogenmass */
  k.x = p.rho * cos( p.phi);           /* Umrechnung */
  k.y = p.rho * sin( p.phi);

  return k;
}


void sortier_ein
( struct punkt *v, struct punkt p, int l)
{
  while( l > 0 && ( v[ l-1].kar.x > p.kar.x ||
                  ( v[ l-1].kar.x == p.kar.x &&
                    v[ l-1].kar.y > p.kar.y)))
  {
    v[ l] = v [ l-1];      /* 16 Bytes umgespeichert */
    l--;
  }

  v[ l] = p;

  return;
}
