/*
 * TUERME VON HANOI
 * Demoprogramm mit Rekursion
 */

# include <stdio.h>

void hanoi( int, int, int);    /* rekursive Funktion */
unsigned long count;

int main()
{
  int k;
  char c[ 2];

  do
  {
    count = 0;

    printf( "\n\nTUERME VON HANOI\n");
    printf( "----------------\n");
    printf( "Die Scheiben sind von oben nach unten ");
    printf( "durchnummeriert!\n");

                     /* Eingabe der Scheibenanzahl n */
    printf( "Anzahl der Scheiben: ");
    scanf( "%d", &k);

    printf( "Bewegung der einzelnen Scheiben:\n");
    printf( "--------------------------------\n");

    /* n Scheiben von Stange 1 nach Stange 3 */
    /* unter Verwendung von Stange 2 */
    hanoi( k, 1, 3);
    printf( "%lu Bewegungen\n", count);

    printf( "Weiter (j/n) ? ");
    scanf( "%1s", c);
  } while( !(c[ 0] == 'n'));

  return 0;
}


/*
 * hanoi: rekursive Funktion
 * Parameter: k .. Anzahl der Scheiben
 *            a .. Startstange
 *            b .. Zielstange
 *   1.  (k-1) Scheiben von Stange a nach Stange c
 *   2.   k. Scheibe von Stange a nach Stange b
 *   3.  (k-1) Scheiben von Stange c nach Stange b
 */

void hanoi( int k, int a, int b)
{
  if( k > 0)
  {
    hanoi( k - 1, a, 6 - a - b);               /* 1. */
    printf("%3d:%d => %d\n", k, a, b);         /* 2. */
    count ++;
    hanoi( k - 1, 6 - a - b, b);               /* 3. */
  }
  return;
}
