/*
 * Testen der Funktionen aus bruch.h
 */

#include <stdio.h>
#include "bruch.h"

int main()
{
  struct bruch t1[] = {{12,8},{0,8},{8,0},{0,0},
                       {-12,8},{12,-8},{-12,-8}};
  struct bruch t2[] = {{12,8},{3,4},{-2,1},{4,2},
                       {0,2},{1,3},{2,3},{1,0},
                       {1,4},{0,-7},{1,0},{2,3}};
  int i;
	
  printf( "Test 1: kuerzen\n");
  for( i = 0; i < sizeof( t1) / sizeof( t1[ 0]); i++)
  {
    printf( "%d/%d => ", t1[ i].Zaehler, t1[ i].Nenner);
    bruchAusgabe( kuerzen( t1[ i])); printf( "\n");
  }

  printf( "\nTest 2: inverse\n");
  for( i = 0; i < sizeof( t1) / sizeof( t1[ 0]); i++)
  {
    printf( "%d/%d => ", t1[ i].Zaehler, t1[ i].Nenner);
    bruchAusgabe( inverse( t1[ i])); printf( "\n");
  }

  printf( "\nTest 3: neg\n");
  for( i = 0; i < sizeof( t1) / sizeof( t1[ 0]); i++)
  {
    printf( "%d/%d => ", t1[ i].Zaehler, t1[ i].Nenner);
    bruchAusgabe( neg( t1[ i])); printf( "\n");
  }

  printf( "\nTest 4: add\n");
  for( i = 0; i < sizeof( t2) / sizeof( t2[ 0]); i += 2)
  {
    printf( "%d/%d + %d/%d => ",
    t2[ i].Zaehler, t2[ i].Nenner,
    t2[ i+1].Zaehler, t2[ i+1].Nenner);
    bruchAusgabe( add( t2[ i], t2[ i+1])); printf( "\n");
  }
	
  printf( "\nTest 5: sub\n");
  for( i = 0; i < sizeof( t2) / sizeof( t2[ 0]); i += 2)
  {
    printf( "%d/%d - %d/%d => ",
    t2[ i].Zaehler, t2[ i].Nenner,
    t2[ i+1].Zaehler, t2[ i+1].Nenner);
    bruchAusgabe( sub( t2[ i], t2[ i+1])); printf( "\n");
  }
	
  printf( "\nTest 6: mult\n");
  for( i = 0; i < sizeof( t2) / sizeof( t2[ 0]); i += 2)
  {
    printf( "%d/%d * %d/%d => ",
    t2[ i].Zaehler, t2[ i].Nenner,
    t2[ i+1].Zaehler, t2[ i+1].Nenner);
    bruchAusgabe( mult( t2[ i], t2[ i+1])); printf( "\n");
  }
	
  printf( "\nTest 7: div\n");
  for( i = 0; i < sizeof( t2) / sizeof( t2[ 0]); i += 2)
  {
    printf( "%d/%d / %d/%d => ",
    t2[ i].Zaehler, t2[ i].Nenner,
    t2[ i+1].Zaehler, t2[ i+1].Nenner);
    bruchAusgabe( div( t2[ i], t2[ i+1])); printf( "\n");
  }

  return 0;
}

/*
   Test 1: kuerzen
   12/8 => 3/2
   0/8 => 0
   8/0 => NaN
   0/0 => NaN
   -12/8 => -3/2
   12/-8 => -3/2
   -12/-8 => 3/2

   Test 2: inverse
   12/8 => 8/12
   0/8 => NaN
   8/0 => NaN
   0/0 => NaN
   -12/8 => 8/-12
   12/-8 => -8/12
   -12/-8 => -8/-12

   Test 3: neg
   12/8 => -12/8
   0/8 => 0/8
   8/0 => NaN
   0/0 => NaN
   -12/8 => 12/8
   12/-8 => -12/-8
   -12/-8 => 12/-8

   Test 4: add
   12/8 + 3/4 => 9/4
   -2/1 + 4/2 => 0
   0/2 + 1/3 => 1/3
   2/3 + 1/0 => NaN
   1/4 + 0/-7 => 1/4
   1/0 + 2/3 => NaN

   Test 5: sub
   12/8 - 3/4 => 3/4
   -2/1 - 4/2 => -4
   0/2 - 1/3 => -1/3
   2/3 - 1/0 => NaN
   1/4 - 0/-7 => 1/4
   1/0 - 2/3 => NaN

   Test 6: mult
   12/8 * 3/4 => 9/8
   -2/1 * 4/2 => -4
   0/2 * 1/3 => 0
   2/3 * 1/0 => NaN
   1/4 * 0/-7 => 0
   1/0 * 2/3 => NaN

   Test 7: div
   12/8 / 3/4 => 2
   -2/1 / 4/2 => -1
   0/2 / 1/3 => 0
   2/3 / 1/0 => NaN
   1/4 / 0/-7 => NaN
   1/0 / 2/3 => NaN
*/